;File: dac41cfg.a51
;Author: Eckart Hartmann Date:15/10/2003
 ; Development progress: Dac841.df
;
;DacCfg==========Configures DAC.
;C Function prototype: char DacCfg(char cDaccon);
;Description of Function: Puts parameter 1 in DACCON SFR.
;User interface: Set the following bits of parameter to 1:
;		Bit 0 to power up DAC0.
;		Bit 1 to power up DAC1.
;		Bit 2 for synchronous DAC update.
;		Bit 3 to clear DAC0.
;		Bit 4 to clear DAC1.
;		Bit 5 for DAC0 range to AVdd (not Vref).
;		Bit 6 for DAC1 range to AVdd (not Vref).
;		Bit 7 for 8bit only results.
;		Call DacCfg. Parameter is put in DACCON.
; 		Returns parameter.
;Robustness:
;Side effects:	Overwrites a, P.
;
NAME DACCFG
$NOMOD51
 $IC(..kei841.inc) ; Parameter passing registers for Keil .
 $IC(..kei841.dat) ; SFR definition for Keil .
;
public _DacCfg

?PR?_DacCfg?DACCFG	SEGMENT CODE
	RSEG	?PR?_DacCfg?DACCFG

_DacCfg:
	mov	DACCON,cP1l
	ret
;
;Function End==========================================================Function End
END



