;File: pwm41cfg.asm
 ; Author: Eckart Hartmann Date:15/10/2003
 ; Development progress: Pwm834.df
;
;PwmCfg==========Configure PWM mode:
;C Function prototype:	char PwmCfg(char cCfg).
;Description of Function:	Select mode and clock source and prescaler.
 ; User interface: Set parameter1 to the required PWMCON register value.
;			Call PwmCfg.
;			Returns bits 4 to 6 (mode) of parameter1. 
;Robustness:	This function terminates any pulse generation in progress and 
;		restarts with the new settings.
;		Ensure PWPO in CFG841 selects required pins.
;Side effects:	None. 
;
NAME PWMCFG
$NOMOD51
 $IC(..kei841.inc) ; Parameter passing registers for Keil .
 $IC(..kei841.dat) ; SFR definition for Keil .
;
public _PwmCfg
;
?PR?_PwmCfg?PWMCFG	SEGMENT CODE
	RSEG	?PR?_PwmCfg?PWMCFG

_PwmCfg:
	mov	PWMCON,cP1l	;Save parameter.
	ret
;
;Function End==========================================================Function End
END
;


